import { jsx } from '@antv/f-engine';
export default (function (props) {
  var node = props.node,
    onClick = props.onClick;
  var children = node.children;
  var renderNodes = function renderNodes(nodes) {
    return jsx("group", null, nodes.map(function (node) {
      var xMin = node.xMin,
        xMax = node.xMax,
        yMin = node.yMin,
        yMax = node.yMax,
        color = node.color,
        children = node.children;
      return jsx("group", {
        onClick: onClick
      }, jsx("rect", {
        attrs: {
          x: xMin,
          y: yMin,
          width: xMax - xMin,
          height: yMax - yMin,
          lineWidth: '1px',
          stroke: '#fff',
          fill: color
        }
      }), children && children.length ? renderNodes(children) : null);
    }));
  };
  return renderNodes(children);
});