import { ComponentType } from '@antv/f-engine';
import { GeometryProps } from '../geometry';
import { DataRecord } from '../../chart/Data';
export interface CandlestickProps<TRecord extends DataRecord = DataRecord> extends GeometryProps<TRecord> {
    /**
     * 柱子的显示比例，默认 0.5
     */
    sizeRatio?: number;
}
declare const _default: (View: ComponentType) => {
    new <TRecord extends DataRecord = DataRecord, IProps extends CandlestickProps<TRecord> = CandlestickProps<TRecord>>(props: IProps & import("../../chart").ChartChildProps<DataRecord>, context?: any): {
        getDefaultCfg(): {
            geomType: string;
        };
        getSize(): number;
        mapping(): any[];
        render(): import("@antv/f-engine").JSX.Element;
        isGeometry: boolean;
        geomType: import("../geometry").GeometryType;
        attrs: any;
        adjust: import("../geometry/Adjust").AdjustProps & {
            adjust: import("../../deps/f2-adjust/src").Adjust;
        };
        dataArray: any;
        dataRecords: any[];
        records: any[];
        mappedArray: any;
        justifyContent: boolean;
        startOnZero: boolean;
        connectNulls: boolean;
        sortable: boolean;
        attrController: import("../../controller/attr").default;
        animation: import("@antv/f-engine").AnimationProps;
        willReceiveProps(nextProps: any): void;
        willMount(): void;
        willUpdate(): void;
        didMount(): void;
        _createAttrs(): void;
        _getThemeAttrsRange(): {
            x: import("../../coord/types").Range;
            y: import("../../coord/types").Range;
            color: any;
            size: any;
            shape: any;
        };
        _adjustScales(): void;
        _groupData(data: any): any[];
        _saveOrigin(originData: any): any[];
        _numberic(data: any): void;
        _adjustData(records: any): any;
        _updateStackRange(field: any, scale: any, dataArray: any): void;
        _processData(): void;
        _sortData(records: any): void;
        getY0Value(): any;
        _getShapeStyle(shape: any, origin: any): any;
        _mapping(records: any): any[];
        getClip(): {
            type: string;
            style: {
                x: number;
                y: number;
                width: number;
                height: number;
            };
        };
        getAttr(attrName: string): any;
        getXScale(): import("../..").Scale;
        getYScale(): import("../..").Scale;
        _getXSnap(invertPointX: any): any;
        _getYSnapRecords(invertPointY: any, records: any): any;
        flatRecords(): any;
        getSnapRecords(point: any, inCoordRange?: any): any[];
        getRecords(data: any, field?: string): any[];
        getLegendItems(): any;
        isSelected(record: any): boolean;
        getSelectionStyle(record: any): import("@antv/f-engine").ShapeStyleProps;
        props: IProps & import("../../chart").ChartChildProps<DataRecord>;
        state: import("../geometry/selection").SelectionState;
        context: import("@antv/f-engine").IContext;
        refs: {
            [key: string]: import("@antv/f-engine/es/component").default<import("@antv/f-engine").IProps, import("@antv/f-engine").IState>;
        };
        updater: import("@antv/f-engine/es/component/updater").Updater<import("../geometry/selection").SelectionState>;
        container: import("@antv/g-lite").Group;
        layout: import("@antv/f-engine").LayoutProps;
        children: import("@antv/f-engine/es/canvas/vnode").VNode | import("@antv/f-engine/es/canvas/vnode").VNode[];
        isMounted: boolean;
        animate: boolean;
        animator: import("@antv/f-engine/es/canvas/render/animator").default;
        destroyed: boolean;
        _vNode: import("@antv/f-engine/es/canvas/vnode").VNode;
        shouldUpdate(_nextProps: IProps & import("../../chart").ChartChildProps<DataRecord>): boolean;
        didUpdate(): void;
        willUnmount(): void;
        didUnmount(): void;
        setState(partialState: import("../geometry/selection").SelectionState, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        setAnimate(animate: boolean): void;
        destroy(): void;
    };
};
export default _default;
